
-- Funktion
Funktion = {};

function Funktion.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

function Funktion:load(xmlFile)

	self.updateSendEvent = SpecializationUtil.callSpecializationsFunction("updateSendEvent");
	self.sideskirtNode = {};
	self.sideskirtNode.node  = Utils.indexToObject(self.components,getXMLString(xmlFile, "vehicle.sideskirtNode#index"));	

	local stuetze = {};
    stuetze.name = getXMLString(xmlFile, "vehicle.stuetze#name");
    stuetze.openSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.stuetze#upSpeedScale"), 1);
    stuetze.closeSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.stuetze#downSpeedScale"), -stuetze.openSpeedScale);
    if stuetze.name ~= nil then
        self.stuetze = stuetze;
    end;
	self.stuetze.active = false;
	
		local tankcalculated = 1;
	activable = false


	local i=0;
    while true do
        local key = string.format("vehicle.animations.animation(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local name = getXMLString(xmlFile, key.."#name");
        if name ~= nil then		
			if name == "stuetze" then			
				local partKey = key..string.format(".part(%d)", 0);
				local loadTime = getXMLFloat(xmlFile, partKey.."#loadTime");
				local endTime = getXMLFloat(xmlFile, partKey.."#endTime");
				
				local currentTime = self:getAnimationTime(self.stuetze.name);
				local speed = 1;
				if currentTime > loadTime/endTime then
					speed = -1;
				end;
				self:playAnimation(self.stuetze.name, speed, currentTime, true);
				self:setAnimationStopTime(self.stuetze.name, loadTime/endTime);
				AnimatedVehicle.updateAnimations(self, 99999999);
				
			end;
        end;
        i = i+1;
    end;
	
	self.jointmove = false;	
	
	
	
end;

function Funktion:delete()
end;

function Funktion:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Funktion:keyEvent(unicode, sym, modifier, isDown)
end;

function Funktion:readStream(streamId, connection)
	-- update animation on synchroninzation --
	local stuetzeAnimTime = streamReadFloat32(streamId);
	
	if stuetzeAnimTime ~= nil then
		local currentTime = self:getAnimationTime(self.stuetze.name);
		local speed = 1;
		if currentTime > stuetzeAnimTime then
			speed = -1;
		end;
		self:playAnimation(self.stuetze.name, speed, currentTime, true);
		self:setAnimationStopTime(self.stuetze.name, stuetzeAnimTime);	
	end;
	AnimatedVehicle.updateAnimations(self, 50);		

end;

function Funktion:writeStream(streamId, connection)
	streamWriteFloat32(streamId, self:getAnimationTime(self.stuetze.name));
end;

function Funktion:update(dt)

 	if self.sideskirtInRange then
	g_currentMission:addExtraPrintText(InputBinding.getKeyNamesOfDigitalAction(InputBinding.Olmer_UP)..": Enrouler et Arroser");
	g_currentMission:addExtraPrintText(InputBinding.getKeyNamesOfDigitalAction(InputBinding.STOP)..": Arreter Enrouler");
	g_currentMission:addExtraPrintText(InputBinding.getKeyNamesOfDigitalAction(InputBinding.Accelerer)..": Accelerer Enroulement");
	end;

	local movejoint = self.jointmove;
	local tankcalculated = 1;


	if InputBinding.hasEvent(InputBinding.Olmer_UP) and self.sideskirtInRange then
			self:playAnimation(self.stuetze.name, currentSpeed, self:getAnimationTime(self.stuetze.name));
			isstuetzeActive = true;
	end;
	if isstuetzeActive and InputBinding.hasEvent(InputBinding.STOP) and self.sideskirtInRange then
			tankcalculated = (self:getAnimationTime(self.stuetze.name)*170/0.1)*0.01;
			self.stuetze.active = true;
			isstuetzeActive = false;
			self:stopAnimation(self.stuetze.name);	
	end;	
	
	if movejoint ~= self.jointmove then 
		self:updateSendEvent();
	end;
	

end;

function Funktion:updateTick(dt)

	if g_currentMission.player ~= nil then
		local nearestDistance = 5;
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);		
		local px, py, pz = getWorldTranslation(self.sideskirtNode.node); 
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.sideskirtInRange = true;
			activable = self.sideskirtInRange
		else
			self.sideskirtInRange = false;
			activable = self.sideskirtInRange
		end;
	end;
	if InputBinding.isPressed(InputBinding.Accelerer) and self.sideskirtInRange then
		currentSpeed = -2
		self:playAnimation(self.stuetze.name, currentSpeed, self:getAnimationTime(self.stuetze.name));
	else
	 	currentSpeed = self.stuetze.closeSpeedScale
	end;

end;

function Funktion:draw()	
end;

function Funktion:updateSendEvent()	

	if g_server ~= nil then
		g_server:broadcastEvent(MPEvent:new(self));
	else
		g_client:getServerConnection():sendEvent(MPEvent:new(self));
	end;

end;


