source("Funktion.lua");
 
-- Unroll
Unroll = {};

function Unroll.prerequisitesPresent(specializations)
    return true;
end;

function Unroll:load(xmlFile)

	self.updateSendEvent = SpecializationUtil.callSpecializationsFunction("updateSendEvent");

	local stuetze = {};
	self.attachPoint = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.attacherPoint#index"));
	self.lastVehicle = nil;
	self.isUsed=false;
	
	self.detachObject = Unroll.detachObject;
	self.attachObject = Unroll.attachObject;
	self.attachPointColli = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.attacherPoint#rootNode"));
	self.Joint = {};
	
end;

function Unroll:delete()
end;

function Unroll:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Unroll:keyEvent(unicode, sym, modifier, isDown)
end;

function Unroll:readStream(streamId, connection)
end;

function Unroll:writeStream(streamId, connection)
end;

function Unroll:update(dt)
	
	local movejoint = self.jointmove;

	if self:getIsActiveForInput() then	
	
		if self.lastVehicle ~= nil then 
			if not self.isUsed then
				if InputBinding.hasEvent(InputBinding.Unroll_ATTACH) then
					self:attachObject(self.lastVehicle[1],self.lastVehicle[2],nil);
					--print("attachObject");
				end;
			else
				if InputBinding.hasEvent(InputBinding.Unroll_ATTACH) then	
					if self.lastVehicle ~= nil then
						v = self.lastVehicle[1];
						if v.stuetze ~= nil then
							tankcalculated = (v:getAnimationTime(v.stuetze.name)*170/0.1)*0.01;
							v.stuetze.active = true;
							isstuetzeActive = false;
						end;
					end;
					self:detachObject();
					--print("detachObject");
				end;
			end;
		end;
		
		if self.attacherVehicle ~= nil then
			local  tractorspeed = self.attacherVehicle.lastSpeed * 3600;
				speedScale = tractorspeed / (3.6*(400/170));
				if speedScale > 0 and self.attacherVehicle.lastAcceleration > 0.0001 then
					NewspeedScale = self.attacherVehicle.lastAcceleration;
				end;
				if self.lastVehicle ~= nil then
					v = self.lastVehicle[1];
					if v.stuetze ~= nil then
						if self.isUsed and NewspeedScale > 0 and self.attacherVehicle.lastAcceleration > 0 then
							v:playAnimation(v.stuetze.name, NewspeedScale, v:getAnimationTime(v.stuetze.name)); 
						else
							v:stopAnimation(v.stuetze.name); 
						end;
					end;
				end;
				isstuetzeActive = true;
		end;
	end;
	
	if movejoint ~= self.jointmove then -- wenn gendert dann sende an server/client (minimierung der bertragungsrate) --
		self:updateSendEvent();
	end;
	

end;

function Unroll:updateTick(dt)
	if self:getIsActiveForInput() then
		--if not self.isUsed then
			self.lastVehicle = nil;
			local x,y,z = getWorldTranslation(self.attachPoint);
			for k,v in pairs(g_currentMission.vehicles) do
				for index,joint in pairs(v.attacherJoints) do
					local x1,y1,z1 = getWorldTranslation(joint.jointTransform);
					local distance = Utils.vector3Length(x-x1,y-y1,z-z1);
					if distance <= 0.25 then						
						self.lastVehicle = {};
						self.lastVehicle[1] = v;
						self.lastVehicle[2] = index;
						break;
					end;
				end;
				if v.attacherJoint ~= nil and self.lastVehicle == nil then
					local x1,y1,z1 = getWorldTranslation(v.attacherJoint.node);
					local distance = Utils.vector3Length(x-x1,y-y1,z-z1);
					if distance <= 0.25 then						
						self.lastVehicle = {};
						self.lastVehicle[1] = v;
						--self.lastVehicle[2] = v.attacherJoint;
						self.lastVehicle[2] = 0;
						break;
					end;
				end;
			end;
		--end;
	end;
end;
function Unroll:attachObject(vehicleId,jointId,noEventSend,vehicle)
	setAttachEvent.sendEvent(self,vehicleId,jointId,noEventSend);
	local joint = self.Joint;
	joint.vehicle = vehicleId;
	local jointFA = nil;
	if jointId == 0 then
		jointFA = vehicleId.attacherJoint;
	else
		jointFA = vehicleId.attacherJoints[jointId];
	end;
	
	if vehicleId.isBroken == true then
		vehicleId.isBroken = false;
	end;
	if self.isServer then
		local colli = jointFA.rootNode; 
		local colli2 = self.attachPointColli;
		local jointTransform = Utils.getNoNil(jointFA.jointTransform, jointFA.node);
		local jointTransform2 = self.attachPoint;
	
		local constr = JointConstructor:new();					
		constr:setActors(colli2, colli);
		constr:setJointTransforms(jointTransform2,  jointTransform);
		for i=1, 3 do
			constr:setTranslationLimit(i-1, true, 0.5, 0.5);
			--constr:setRotationLimit(i-1,0,0);
		end;
		joint.index = constr:finalize();
		if not self.Joint.vehicle.isControlled and self.Joint.vehicle.motor ~= nil and self.Joint.vehicle.wheels~= nil then
			for k,wheel in pairs(vehicleId.wheels) do
				--print("setWheelShapeProps attachObject");
				--setWheelShapeProps(wheel.node, wheel.wheelShape, 0, vehicleId.motor.brakeForce, 0);
				--setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0, 0);
			end;
		end;
	end;
	self.isUsed = true;
	self.lastVehicle = nil;
end;
function Unroll:detachObject(noEventSend)
	setDetachEvent.sendEvent(self,noEventSend);
	if self.isServer then
		removeJoint(self.Joint.index);	
		if not self.Joint.vehicle.isControlled and self.Joint.vehicle.motor ~= nil and self.Joint.vehicle.wheels~= nil then
			for k,wheel in pairs(self.Joint.vehicle.wheels) do
				--print("setWheelShapeProps detachObject");
				--setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.Joint.vehicle.motor.brakeForce, 0);
				--setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0, 0);
			end;
		end;
	end;
	self.Joint = nil;
	self.Joint = {};
	self.isUsed = false;
end;
function Unroll:draw()	
	if self.lastVehicle ~= nil then
		if self.isUsed then
			g_currentMission:addHelpButtonText(g_i18n:getText("ABSCHLEPPSTANGE_DetachObject"), InputBinding.Unroll_ATTACH);
		else 
			g_currentMission:addHelpButtonText(g_i18n:getText("ABSCHLEPPSTANGE_AttachObject"), InputBinding.Unroll_ATTACH);
		end;
	end;
end;

function Unroll:updateSendEvent()	

	if g_server ~= nil then
		g_server:broadcastEvent(MPEvent:new(self));
	else
		g_client:getServerConnection():sendEvent(MPEvent:new(self));
	end;

end;


